﻿using Spire.Cloud.Pdf.Sdk.Api;
using Spire.Cloud.Pdf.Sdk.Client;
using Spire.Cloud.Pdf.Sdk.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CloudPdf
{
    class PdfBookmarksApiDemo
    {
        static String appId = "your id";
        static String appKey = "your key";
        public static void AddBookmark()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfBookmarksApi pdfBookmarkApi = new PdfBookmarksApi(PdfConfiguration);

            string name = "AddBookmark.pdf";
            string outPath = "output/AddBookmark_output.pdf";
            string bookmarkPath = "1";
            Bookmark bookmark = new Bookmark();
            bookmark.Title = "testTitle";
            bookmark.Color = new Color(0, 255, 0, 0);
            bookmark.PageNumber = 1;
            bookmark.Bold = true;
            bookmark.Italic = true;
            bookmark.PageDisplay = Bookmark.PageDisplayEnum.XYZ;
            bookmark.PageDisplayLeft = 10;
            bookmark.PageDisplayTop = 20;
            string folder = "input";
            string password = null;
            pdfBookmarkApi.AddBookmark(name, outPath, bookmarkPath, bookmark, folder, password);
        }

        public static void AddBookmarkWithGoToAction()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfBookmarksApi pdfBookmarkApi = new PdfBookmarksApi(PdfConfiguration);

            string name = "AddBookmarkWithGoToAction.pdf";
            string outPath = "output/AddBookmarkWithGoToAction_output.pdf";
            string bookmarkPath = "1";
            Bookmark bookmark = new Bookmark();
            bookmark.Title = "testTitle";
            bookmark.Color = new Color(0, 255, 0, 0);
            bookmark.Bold = true;
            bookmark.Italic = true;
            bookmark.Action = Bookmark.ActionEnum.GoTo;
            bookmark.PageDisplay = Bookmark.PageDisplayEnum.XYZ;
            bookmark.PageNumber = 1;
            bookmark.PageDisplayLeft = 10;
            bookmark.PageDisplayTop = 20;
            string folder = "input";
            string password = null;
            pdfBookmarkApi.AddBookmark(name, outPath, bookmarkPath, bookmark, folder, password);
        }

        public static void DeleteBookmark()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfBookmarksApi pdfBookmarkApi = new PdfBookmarksApi(PdfConfiguration);

            string name = "DeleteBookmark.pdf";
            string outPath = "output/DeleteBookmark_output.pdf";
            string bookmarkPath = "1";
            string folder = "input";
            string password = null;
            pdfBookmarkApi.DeleteBookmark(name, outPath, bookmarkPath, folder, password);
        }
        public static void DeleteChildBookmark()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfBookmarksApi pdfBookmarkApi = new PdfBookmarksApi(PdfConfiguration);

            string name = "DeleteChildBookmark.pdf";
            string outPath = "output/DeleteChildBookmark_output.pdf";
            string bookmarkPath = "1-2";
            string folder = "input";
            string password = null;
            pdfBookmarkApi.DeleteBookmark(name, outPath, bookmarkPath, folder, password);
        }

        public static void DeleteBookmarks()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfBookmarksApi pdfBookmarkApi = new PdfBookmarksApi(PdfConfiguration);

            string name = "DeleteBookmarks.pdf";
            string outPath = "output/DeleteAllBookmarks_output.pdf";
            string folder = "input";
            string password = null;
            pdfBookmarkApi.DeleteBookmarks(name, outPath, folder, password);
        }

        public static void GetBookmarkInfo()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfBookmarksApi pdfBookmarkApi = new PdfBookmarksApi(PdfConfiguration);

            string name = "GetBookmarkInfo.pdf";
            string bookmarkPath = "1-2";
            string folder = "input";
            string password = null;
            var response = pdfBookmarkApi.GetBookmarkInfo(name, bookmarkPath, folder, password);
        }

        public static void GetBookmarksInfo()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfBookmarksApi pdfBookmarkApi = new PdfBookmarksApi(PdfConfiguration);

            string name = "GetBookmarksInfo.pdf";
            string folder = "input";
            string password = null;
            var response = pdfBookmarkApi.GetBookmarksInfo(name, folder, password);
        }

        public static void UpdateBookmark()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfBookmarksApi pdfBookmarkApi = new PdfBookmarksApi(PdfConfiguration);

            string name = "UpdateBookmark.pdf";
            string outPath = "output/UpdateBookmark_output.pdf";
            string bookmarkPath = "1-1";
            Bookmark bookmark = new Bookmark();
            bookmark.PageNumber = 1;
            bookmark.Title = "updateTitile";
            bookmark.Color = new Color(0, 255, 0, 0);
            bookmark.Bold = false;
            bookmark.Italic = false;
            bookmark.PageDisplay = Bookmark.PageDisplayEnum.XYZ;
            bookmark.PageDisplayLeft = 10;
            bookmark.PageDisplayTop = 20;
            string folder = "input";
            string password = null;
            pdfBookmarkApi.UpdateBookmark(name, outPath, bookmarkPath, bookmark, folder, password);
        }

    }
}
