﻿using Spire.Cloud.Pdf.Sdk.Api;
using Spire.Cloud.Pdf.Sdk.Client;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace CloudPdf
{
    class PdfConvertApiDemo
    {
        static String appId = "your id";
        static String appKey = "your key";

        public static void ConvertPdfInRequestToDoc()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToDoc.pdf";
            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToDoc(file, null);        
        }

        public static void ConvertPdfInRequestToDocWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToDocWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToDoc(file, password);
        }

        public static void ConvertPdfInStorageToDocWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToDocWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToDocWithPassword_output.doc";
            pdfConvertApi.ConvertPdfInStorageToDoc(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInRequestToDocx()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToDocx.pdf";
            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToDocx(file, null);
        }

        public static void ConvertPdfInRequestToDocxWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToDocxWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToDocx(file, password);
        }

        public static void ConvertPdfInRequestToHtml()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToHtml.pdf";
            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToHtml(file, null);
        }

        public static void ConvertPdfInRequestToHtmlWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToHtmlWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToHtml(file, password);
        }

        public static void ConvertPdfInRequestToPcl()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToPcl.pdf";
            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToPcl(file, null);
        }

        public static void ConvertPdfInRequestToPclWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToPclWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToPcl(file, password);
        }

        public static void ConvertPdfInRequestToPng()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string password = null;
            string inputFilePath = "input/convertPdfInRequestToPng.pdf";
            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToPng(file, null, null, password);
        }

        public static void ConvertPdfInRequestToPngWithDPI()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string password = null;
            int dpiX = 300;
            int dpiY = 300;
            string inputFilePath = "input/convertPdfInRequestToPngWithDPI.pdf";
            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToPng(file, dpiX, dpiY, password);
        }

        public static void ConvertPdfInRequestToPngWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToPngWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToPng(file, null, null, password);
        }

        public static void ConvertPdfInRequestToPs()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string password = null;
            string inputFilePath = "input/convertPdfInRequestToPs.pdf";
            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToPs(file, password);
        }

        public static void ConvertPdfInRequestToPsWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToPsWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToPs(file, password);
        }

        public static void ConvertPdfInRequestToSvg()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string password = null;
            string inputFilePath = "input/convertPdfInRequestToSvg.pdf";
            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToSvg(file, password);
        }

        public static void ConvertPdfInRequestToSvgWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToSvgWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToSvg(file, password);
        }

        public static void ConvertPdfInRequestToXps()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string password = null;
            string inputFilePath = "input/convertPdfInRequestToXps.pdf";
            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToXps(file, password);
        }

        public static void ConvertPdfInRequestToXpsWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/convertPdfInRequestToXpsWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.ConvertPdfInRequestToXps(file, password);
        }

        public static void ConvertPdfInStorageToDoc()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToDoc.pdf";
            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToDoc_output.doc";
            pdfConvertApi.ConvertPdfInStorageToDoc(filename, destFilePath, folder, null);
        }

        public static void ConvertPdfInStorageToDocWithoutFolder()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToDocWithoutFolder.pdf";
            string password = null;
            string folder = null;
            string destFilePath = "output/convertPdfInStorageToDocWithoutFolder_output.doc";
            pdfConvertApi.ConvertPdfInStorageToDoc(filename, destFilePath, folder, password);
        }
     
        public static void ConvertPdfInStorageToDocx()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToDocx.pdf";
            string password = null;
            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToDocx_output.docx";
            pdfConvertApi.ConvertPdfInStorageToDocx(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToDocxWithoutFolder()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToDocxWithoutFolder.pdf";
            string password = null;
            string folder = null;
            string destFilePath = "output/convertPdfInStorageToDocxWithoutFolder_output.docx";
            pdfConvertApi.ConvertPdfInStorageToDocx(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToDocxWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToDocxWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToDocxWithPassword_output.docx";
            pdfConvertApi.ConvertPdfInStorageToDocx(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToHtml()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToHtml.pdf";
            string password = null;
            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToHtml_output.html";
            pdfConvertApi.ConvertPdfInStorageToHtml(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToHtmlWithoutFolder()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToHtmlWithoutFolder.pdf";
            string password = null;
            string folder = null;
            string destFilePath = "output/convertPdfInStorageToHtmlWithoutFolder_output.html";
            pdfConvertApi.ConvertPdfInStorageToHtml(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToHtmlWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToHtmlWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToHtmlWithPassword_output.html";
            pdfConvertApi.ConvertPdfInStorageToHtml(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToPcl()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToPcl.pdf";
            string password = null;
            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToPcl_output.pcl";
            pdfConvertApi.ConvertPdfInStorageToPcl(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToPclWithoutFolder()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToPclWithoutFolder.pdf";
            string password = null;
            string folder = null;
            string destFilePath = "output/convertPdfInStorageToPclWithoutFolder_output.pcl";
            pdfConvertApi.ConvertPdfInStorageToPcl(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToPclWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToPclWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToPclWithPassword_output.pcl";
            pdfConvertApi.ConvertPdfInStorageToPcl(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToPng()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToPng.pdf";
            string password = null;
            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToPng_output.png";
            pdfConvertApi.ConvertPdfInStorageToPng(filename, destFilePath, null, null, folder, password);
        }

        public static void ConvertPdfInStorageToPngWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToPngWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToPngWithPassword_output.png";
            pdfConvertApi.ConvertPdfInStorageToPng(filename, destFilePath, null, null, folder, password);
        }

        public static void ConvertPdfInStorageToPngWithDPI()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToPngWithDPI.pdf";
            string password = null;
            string folder = "input";
            int dpiX = 300;
            int dpiY = 300;
            string destFilePath = "output/convertPdfInStorageToPngWithDPI_output.png";
            pdfConvertApi.ConvertPdfInStorageToPng(filename, destFilePath, dpiX, dpiY, folder, password);
        }

        public static void ConvertPdfInStorageToPs()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToPs.pdf";
            string password = null;
            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToPs_output.ps";
            pdfConvertApi.ConvertPdfInStorageToPs(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToPsWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToPsWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToPsWithPassword_output.ps";
            pdfConvertApi.ConvertPdfInStorageToPs(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToSvg()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToSvg.pdf";
            string password = null;
            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToSvg_output.svg";
            pdfConvertApi.ConvertPdfInStorageToSvg(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToSvgWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToSvgWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToSvgWithPassword_output.svg";
            pdfConvertApi.ConvertPdfInStorageToSvg(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToXps()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToXps.pdf";
            string password = null;
            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToXps_output.xps";
            pdfConvertApi.ConvertPdfInStorageToXps(filename, destFilePath, folder, password);
        }

        public static void ConvertPdfInStorageToXpsWithPassword()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string filename = "convertPdfInStorageToXpsWithPassword.pdf";

            byte[] b = System.Text.Encoding.UTF8.GetBytes("123");
            string password = Convert.ToBase64String(b);
            password = password.Replace("+", "%2B");

            string folder = "input";
            string destFilePath = "output/convertPdfInStorageToXpsWithPassword_output.xps";
            pdfConvertApi.ConvertPdfInStorageToXps(filename, destFilePath, folder, password);
        }

        public static void CreatePdfFromXpsInRequest()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string inputFilePath = "input/createPdfFromXpsInRequest.xps";

            System.IO.Stream file = new FileStream(inputFilePath, FileMode.Open);
            var response = pdfConvertApi.CreatePdfFromXpsInRequest(file);          
        }

        public static void CreatePdfFromXpsInStorage()
        {
            Configuration pdfConfiguration = new Configuration(appId, appKey);
            PdfConvertApi pdfConvertApi = new PdfConvertApi(pdfConfiguration);
            string resultFileName = "createPdfFromXpsInStorage_output.pdf";
            string inputFilePath = "input/createPdfFromXpsInStorage.xps";
            string destFileFolder = "output";
            pdfConvertApi.CreatePdfFromXpsInStorage(resultFileName, inputFilePath, destFileFolder);
        }
    }
}
