﻿using Spire.Cloud.Pdf.Sdk.Api;
using Spire.Cloud.Pdf.Sdk.Client;
using Spire.Cloud.Pdf.Sdk.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CloudPdf
{
    class PdfPropertiesApiDemo
    {
        static String appId = "your id";
        static String appKey = "your key";
        public static void AddOrUpdateProperties()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfPropertiesApi pdfPropertiesApi = new PdfPropertiesApi(PdfConfiguration);

            string name = "AddOrUpdateProperties.pdf";
            string outPath = "output/AddOrUpdateProperties_output.pdf";
            DocumentProperties properties = new DocumentProperties();
            properties.List = new List<DocumentProperty>();
            //building properties
            properties.List.Add(new DocumentProperty("author", "Simon", true));
            properties.List.Add(new DocumentProperty("creationdate", "2019/10/14 11:01:55", true));
            properties.List.Add(new DocumentProperty("creator", "Tom", true));
            properties.List.Add(new DocumentProperty("keywords", "the keywords", true));
            properties.List.Add(new DocumentProperty("modificationdate", "2019/10/15 15:41:33", true));
            properties.List.Add(new DocumentProperty("producer", "Spire.could.pdf", true));
            properties.List.Add(new DocumentProperty("subject", "the subject", true));
            properties.List.Add(new DocumentProperty("title", "the title", true));
            //customize properties
            properties.List.Add(new DocumentProperty("customerProperty1", "the customerProperty1", false));
            properties.List.Add(new DocumentProperty("customerProperty2", "the customerProperty2", false));

            string folder = "input";
            string password = null;
            pdfPropertiesApi.AddOrUpdateProperties(name, outPath, properties, folder, password);
        }

        public static void DeleteProperties()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfPropertiesApi pdfPropertiesApi = new PdfPropertiesApi(PdfConfiguration);

            string name = "DeleteProperties.pdf";
            string outPath = "output/DeleteProperties_output.pdf";
            string folder = "input";
            string password = null;
            pdfPropertiesApi.DeleteProperties(name, outPath, folder, password);
        }

        public static void GetProperties()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfPropertiesApi pdfPropertiesApi = new PdfPropertiesApi(PdfConfiguration);

            string name = "GetProperties.pdf";
            string folder = "input";
            string password = null;
            var response = pdfPropertiesApi.GetProperties(name, folder, password);

        }
    }
}
