﻿using Spire.Cloud.Pdf.Sdk.Api;
using Spire.Cloud.Pdf.Sdk.Client;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CloudPdf
{
    class PdfSecurityApiDemo
    {
        static String appId = "your id";
        static String appKey = "your key";
        public static void DecryptDocumentInRequest()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfSecurityApi PdfSecurityApi = new PdfSecurityApi(PdfConfiguration);

            using (System.IO.Stream file = new FileStream("DecryptDocumentInRequest.pdf", FileMode.Open))
            {
                string password = ToBase64String("123");
                var response = PdfSecurityApi.DecryptDocumentInRequest(file, password);
            }
        }

        public static void DecryptDocumentInRequestWithOwnerPsw()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfSecurityApi PdfSecurityApi = new PdfSecurityApi(PdfConfiguration);

            using (System.IO.Stream file = new FileStream("DecryptDocumentInRequestWithOwnerPsw.pdf", FileMode.Open))
            {
                string password = ToBase64String("321");
                var response = PdfSecurityApi.DecryptDocumentInRequest(file, password);
            }
        }

        public static void DecryptDocumentInRequestWithUserPswAndOwnerPsw()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfSecurityApi PdfSecurityApi = new PdfSecurityApi(PdfConfiguration);

            using (System.IO.Stream file = new FileStream("DecryptDocumentInRequestWithUserPswAndOwnerPsw.pdf", FileMode.Open))
            {
                string password = ToBase64String("321");
                var response = PdfSecurityApi.DecryptDocumentInRequest(file, password);
            }
        }

        public static void DecryptDocumentInStorage()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfSecurityApi PdfSecurityApi = new PdfSecurityApi(PdfConfiguration);

            string name = "DecryptDocumentInStorage.pdf";
            string outPath = "output/DecryptDocumentInStorage_output.pdf";
            string password = ToBase64String("123");
            string folder = "input";
            PdfSecurityApi.DecryptDocumentInStorage(name, outPath, password, folder);
        }

        public static void EncryptDocumentInRequest()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfSecurityApi PdfSecurityApi = new PdfSecurityApi(PdfConfiguration);

            using (System.IO.Stream file = new FileStream("EncryptDocumentInRequest.pdf", FileMode.Open))
            {
                string userPassword = ToBase64String("e123");
                string ownerPassword = ToBase64String("e321");
                string keySize = null;
                List<string> permissionsFlags = null;
                string password = null;
                var response = PdfSecurityApi.EncryptDocumentInRequest(file, userPassword, ownerPassword, keySize, permissionsFlags, password);
            }
        }

        public static void EncryptDocumentInRequestWithOriginalUserPsw()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfSecurityApi PdfSecurityApi = new PdfSecurityApi(PdfConfiguration);

            using (System.IO.Stream file = new FileStream("EncryptDocumentInRequestWithOriginalUserPsw.pdf", FileMode.Open))
            {
                string userPassword = ToBase64String("e123");
                string ownerPassword = ToBase64String("e321");
                string keySize = null;
                List<string> permissionsFlags = null;
                string password = ToBase64String("123");
                var response = PdfSecurityApi.EncryptDocumentInRequest(file, userPassword, ownerPassword, keySize, permissionsFlags, password);             
            }
        }

        public static void EncryptDocumentInRequestWithOriginalOwnerPsw()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfSecurityApi PdfSecurityApi = new PdfSecurityApi(PdfConfiguration);

            using (System.IO.Stream file = new FileStream("EncryptDocumentInRequestWithOriginalOwnerPsw.pdf", FileMode.Open))
            {
                string userPassword = ToBase64String("e123");
                string ownerPassword = ToBase64String("e321");
                string keySize = null;
                List<string> permissionsFlags = null;
                string password = ToBase64String("321"); ;
                var response = PdfSecurityApi.EncryptDocumentInRequest(file, userPassword, ownerPassword, keySize, permissionsFlags, password);
            }
        }

        public static void EncryptDocumentInRequestWithOriginalUserPswAndOwnerPsw()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfSecurityApi PdfSecurityApi = new PdfSecurityApi(PdfConfiguration);

            using (System.IO.Stream file = new FileStream("EncryptDocumentInRequestWithOriginalUserPswAndOwnerPsw.pdf", FileMode.Open))
            {
                string userPassword = ToBase64String("e123");
                string ownerPassword = ToBase64String("e321");
                string keySize = null;
                List<string> permissionsFlags = null;
                string password = ToBase64String("321"); ;
                var response = PdfSecurityApi.EncryptDocumentInRequest(file, userPassword, ownerPassword, keySize, permissionsFlags, password);   
            }
        }

        public static void EncryptDocumentInRequestWithKeySizeAndPermissions()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfSecurityApi PdfSecurityApi = new PdfSecurityApi(PdfConfiguration);

            using (System.IO.Stream file = new FileStream("EncryptDocumentInRequestWithKeySizeAndPermissions.pdf", FileMode.Open))
            {
                string userPassword = ToBase64String("123");
                string ownerPassword = ToBase64String("321");
                string keySize = "Key40Bit";
                List<string> permissionsFlags = new List<string>();
                permissionsFlags.Add("Print");
                permissionsFlags.Add("EditContent");
                string password = null;
                var response = PdfSecurityApi.EncryptDocumentInRequest(file, userPassword, ownerPassword, keySize, permissionsFlags, password);
            }
        }
        public static void EncryptDocumentInStorage()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfSecurityApi PdfSecurityApi = new PdfSecurityApi(PdfConfiguration);

            string name = "EncryptDocumentInStorage.pdf";
            string outPath = "output/EncryptDocumentInStorage_output.pdf";
            string userPassword = ToBase64String("123");
            string ownerPassword = ToBase64String("321");
            string keySize = null;
            List<string> permissionsFlags = null;
            string folder = "input";
            string password = null;
            PdfSecurityApi.EncryptDocumentInStorage(name, outPath, userPassword, ownerPassword, keySize, permissionsFlags, folder, password);
        }

        public static void EncryptDocumentInStorageWithKeySizeAndPermissions()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfSecurityApi PdfSecurityApi = new PdfSecurityApi(PdfConfiguration);

            string name = "EncryptDocumentInStorageWithKeySizeAndPermissions.pdf";
            string outPath = "output/EncryptDocumentInStorageWithKeySizeAndPermissions_output.pdf";
            string userPassword = ToBase64String("123");
            string ownerPassword = ToBase64String("321");
            string keySize = "Key40Bit";
            List<string> permissionsFlags = new List<string>();
            permissionsFlags.Add("Print");
            permissionsFlags.Add("EditContent");
            string folder = "input";
            string password = null;
            PdfSecurityApi.EncryptDocumentInStorage(name, outPath, userPassword, ownerPassword, keySize, permissionsFlags, folder, password);
        }

        private static string ToBase64String(string value)
        {
            byte[] b = System.Text.Encoding.UTF8.GetBytes(value);
            string base64String = Convert.ToBase64String(b);
            base64String = base64String.Replace("+", "%2B");
            return base64String;
        }
    }
}
