﻿using Spire.Cloud.Pdf.Sdk.Api;
using Spire.Cloud.Pdf.Sdk.Client;
using Spire.Cloud.Pdf.Sdk.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CloudPdf
{
    class PdfTextApiDemo
    {
        static String appId = "your id";
        static String appKey = "your key";
        public static void AddText()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfTextApi PdfTextApi = new PdfTextApi(PdfConfiguration);

            string name = "AddText.pdf";
            string outPath = "output/AddText_output.pdf";
            int pageNumber = 1;
            string folder = "input";
            Spire.Cloud.Pdf.Sdk.Model.Text text = new Spire.Cloud.Pdf.Sdk.Model.Text("This is a test.",
                new Font(Font.FontTypeEnum.Standard, "Helvetica", 12, Font.FontStyleEnum.Regular),
                new RectangleF(10, 10, 100, 50));

            text.BackgroundColor = new Color(0, 0, 0, 255);
            PdfTextApi.AddText(name, outPath, pageNumber, text, folder, null);
        }

        public static void AddTextWithBounds()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfTextApi PdfTextApi = new PdfTextApi(PdfConfiguration);

            string name = "AddTextWithBounds.pdf";
            string outPath = "output/AddTextWithBounds_output.pdf";
            int pageNumber = 1;
            string folder = "input";
            Spire.Cloud.Pdf.Sdk.Model.Text text = new Spire.Cloud.Pdf.Sdk.Model.Text("This is a test.",
                new Font(Font.FontTypeEnum.Standard, "Helvetica", 12, Font.FontStyleEnum.Italic),
                new RectangleF(10, 10, 100, 50));
            text.BackgroundColor = new Color(0, 0, 0, 255);
            text.ForegroundColor = new Color(0, 0, 255, 0);
            PdfTextApi.AddText(name, outPath, pageNumber, text, folder, null);
        }

        public static void AddTextWithTrueTypeFont()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfTextApi PdfTextApi = new PdfTextApi(PdfConfiguration);

            string name = "AddTextWithTrueTypeFont.pdf";
            string outPath = "output/AddTextWithTrueTypeFont_output.pdf";
            int pageNumber = 1;
            string folder = "input";
            Spire.Cloud.Pdf.Sdk.Model.Text text = new Spire.Cloud.Pdf.Sdk.Model.Text("This is a test.",
                new Font(Font.FontTypeEnum.TrueType, "Arial", 12, Font.FontStyleEnum.Regular),
                new RectangleF(10, 10, 100, 50));
            text.BackgroundColor = new Color(0, 0, 0, 255);

            PdfTextApi.AddText(name, outPath, pageNumber, text, folder, null);
        }

        public static void AddTextWithUnicodeTrueTypeFont()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfTextApi PdfTextApi = new PdfTextApi(PdfConfiguration);

            string name = "AddTextWithUnicodeTrueTypeFont.pdf";
            string outPath = "output/AddTextWithUnicodeTrueTypeFont_output.pdf";
            int pageNumber = 1;
            string folder = "input";
            Spire.Cloud.Pdf.Sdk.Model.Text text = new Spire.Cloud.Pdf.Sdk.Model.Text("This is a test.",
                new Font(Font.FontTypeEnum.UnicodeTrueType, "Arial", 12, Font.FontStyleEnum.Regular),
                new RectangleF(10, 10, 100, 50));
            text.BackgroundColor = new Color(0, 255, 0, 0);
            PdfTextApi.AddText(name, outPath, pageNumber, text, folder, null);
        }

        public static void AddTextWithSpaces()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfTextApi PdfTextApi = new PdfTextApi(PdfConfiguration);

            string name = "AddTextWithSpaces.pdf";
            string outPath = "output/AddTextWithSpaces_output.pdf";
            int pageNumber = 1;
            string folder = "input";
            Spire.Cloud.Pdf.Sdk.Model.Text text = new Spire.Cloud.Pdf.Sdk.Model.Text("This is a test!This is a test!This is a test!This is a test!This is a test!This is a test!This is a test!This is a test!This is a test!This is a test!",
                new Font(Font.FontTypeEnum.Standard, "Helvetica", 9, Font.FontStyleEnum.Regular),
                new RectangleF(10, 10, 100, 200));
            text.BackgroundColor = new Color(0, 0, 0, 255);
            text.CharSpacing = 20;
            text.FirstLineIndent = 20;
            text.HorizontalAlignment = Spire.Cloud.Pdf.Sdk.Model.Text.HorizontalAlignmentEnum.Left;
            text.LineSpacing = 20;
            text.VerticalAlignment = Spire.Cloud.Pdf.Sdk.Model.Text.VerticalAlignmentEnum.Bottom;
            text.WordSpacing = 20;
            PdfTextApi.AddText(name, outPath, pageNumber, text, folder, null);
        }

        public static void AddTextWithWordWrapWord()
        {
            Configuration PdfConfiguration = new Configuration(appId, appKey);
            PdfTextApi PdfTextApi = new PdfTextApi(PdfConfiguration);

            string name = "AddTextWithWordWrapWord.pdf";
            string outPath = "output/AddTextWithWordWrapWord_output.pdf";
            int pageNumber = 1;
            string folder = "input";
            Spire.Cloud.Pdf.Sdk.Model.Text text = new Spire.Cloud.Pdf.Sdk.Model.Text("This is a test!This is a test!This is a test!This is a test!This is a test!This is a test!This is a test!This is a test!This is a test!This is a test!",
                new Font(Font.FontTypeEnum.Standard, "Helvetica", 12, Font.FontStyleEnum.Bold),
                new RectangleF(10, 10, 100, 50));
            text.BackgroundColor = new Color(0, 0, 0, 255);
            text.CharSpacing = 20;
            text.WordWrap = Spire.Cloud.Pdf.Sdk.Model.Text.WordWrapEnum.Word;
            PdfTextApi.AddText(name, outPath, pageNumber, text, folder, null);
        }
    }
}
